VTK: vtkOBJImporter Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkOBJImporter Class Reference

import from .obj wavefront files More...

`#include <vtkOBJImporter.h>`

Inheritance diagram for vtkOBJImporter:
[legend]
Collaboration diagram for vtkOBJImporter:
[legend]

## Public Types
typedef vtkImporter | Superclass
Public Types inherited from vtkImporter
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkOBJImporter * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
std::string | GetOutputsDescription () override
| Get a printable string describing all outputs. More...
std::string | GetOutputDescription (int idx)
| Get a string describing an output. More...
void | SetFileName (VTK_FILEPATH const char *arg)
| Specify the name of the file to read. More...
void | SetFileNameMTL (VTK_FILEPATH const char *arg)
| Specify the name of the file to read. More...
void | SetTexturePath (VTK_FILEPATH const char *path)
| Specify the name of the file to read. More...
VTK_FILEPATH const char * | GetFileName () const
| Specify the name of the file to read. More...
VTK_FILEPATH const char * | GetFileNameMTL () const
| Specify the name of the file to read. More...
VTK_FILEPATH const char * | GetTexturePath () const
| Specify the name of the file to read. More...
Public Member Functions inherited from vtkImporter
vtkImporter * | NewInstance () const
virtual vtkIdType | GetNumberOfAnimations ()
| Get the number of available animations. More...
virtual std::string | GetAnimationName (vtkIdType vtkNotUsed(animationIndex))
| Get the name of an animation. More...
virtual vtkIdType | GetNumberOfCameras ()
| Get the number of available cameras. More...
virtual std::string | GetCameraName (vtkIdType vtkNotUsed(camIndex))
| Get the name of a camera. More...
virtual void | SetCamera (vtkIdType vtkNotUsed(camIndex))
| Enable a specific camera. More...
virtual bool | GetTemporalInformation (vtkIdType animationIndex, double frameRate, int &nbTimeSteps, double timeRange[2], vtkDoubleArray *timeSteps)
| Get temporal information for the provided animationIndex and frameRate. More...
virtual void | UpdateTimeStep (double timeValue)
| Import the actors, camera, lights and properties at a specific time value. More...
virtual vtkRenderer * | GetRenderer ()
| Get the renderer that contains the imported actors, cameras and lights. More...
virtual void | SetRenderWindow (vtkRenderWindow *)
| Set the vtkRenderWindow to contain the imported actors, cameras and lights, If no vtkRenderWindow is set, one will be created and can be obtained with the GetRenderWindow method. More...
virtual vtkRenderWindow * | GetRenderWindow ()
| Set the vtkRenderWindow to contain the imported actors, cameras and lights, If no vtkRenderWindow is set, one will be created and can be obtained with the GetRenderWindow method. More...
void | Read ()
| Import the actors, cameras, lights and properties into a vtkRenderWindow. More...
void | Update ()
| Import the actors, cameras, lights and properties into a vtkRenderWindow. More...
virtual void | EnableAnimation (vtkIdType vtkNotUsed(animationIndex))
| Enable/Disable/Get the status of specific animations. More...
virtual void | DisableAnimation (vtkIdType vtkNotUsed(animationIndex))
| Enable/Disable/Get the status of specific animations. More...
virtual bool | IsAnimationEnabled (vtkIdType vtkNotUsed(animationIndex))
| Enable/Disable/Get the status of specific animations. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkOBJImporter * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkOBJImporter * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkImporter
static vtkTypeBool | IsTypeOf (const char *type)
static vtkImporter * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkOBJImporter ()
| ~vtkOBJImporter () override
int | ImportBegin () override
void | ImportEnd () override
void | ReadData () override
Protected Member Functions inherited from vtkImporter
| vtkImporter ()
| ~vtkImporter () override
virtual void | ImportActors (vtkRenderer *)
virtual void | ImportCameras (vtkRenderer *)
virtual void | ImportLights (vtkRenderer *)
virtual void | ImportProperties (vtkRenderer *)
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkSmartPointer< vtkOBJPolyDataProcessor > | Impl
Protected Attributes inherited from vtkImporter
vtkRenderer * | Renderer
vtkRenderWindow * | RenderWindow
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkImporter
static std::string | GetDataSetDescription (vtkDataSet *ds, vtkIndent indent)
static std::string | GetArrayDescription (vtkAbstractArray *array, vtkIndent indent)
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

import from .obj wavefront files

Note
  {updated by peter karasev, 2015 to read texture coordinates + material properties}
  {An example of a supported (*).mtl file is show below. Lighting values and texture images are specified, and a corresponding vtkActor with properties and vtkTexture will be created upon import. }

# Wavefront material file saved from Meshlab

newmtl material_0 Ka 0.400000 0.400000 0.400000 Kd 0.5 0.5 0.5 Ks 0.85 0.9 0.9 illum 2 Ns 0.000000 map_Kd map1024.png

newmtl material_1 Ka 0.200000 0.200000 0.200000 Kd 0.666667 0.666667 0.666667 Ks 1.000000 0.9 1.000000 illum 2 Ns 0.000000 map_Kd flare.jpg

                       from Wavefront .obj & associated .mtl files.

Thanks - Peter Karasev (Georgia Tech / Keysight Technologies Inc),:
  Allen Tannenbaum (SUNY Stonybrook), Patricio Vela (Georgia Tech)

See also
  vtkImporter

Examples:
  vtkOBJImporter (Examples)

Online Examples:

Tests:
  vtkOBJImporter (Tests)

Definition at line 66 of file vtkOBJImporter.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkImporter vtkOBJImporter::Superclass

Definition at line 71 of file vtkOBJImporter.h.

## Constructor & Destructor Documentation

## ◆ vtkOBJImporter()

vtkOBJImporter::vtkOBJImporter | ( |  | ) |
| protected

## ◆ ~vtkOBJImporter()

vtkOBJImporter::~vtkOBJImporter | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkOBJImporter* vtkOBJImporter::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkOBJImporter::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkOBJImporter::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkImporter.

## ◆ SafeDownCast()

static vtkOBJImporter* vtkOBJImporter::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkOBJImporter::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkImporter.

## ◆ NewInstance()

vtkOBJImporter* vtkOBJImporter::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkOBJImporter::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkImporter.

## ◆ SetFileName()

void vtkOBJImporter::SetFileName | ( | VTK_FILEPATH const char * | arg | ) |

Specify the name of the file to read.

## ◆ SetFileNameMTL()

void vtkOBJImporter::SetFileNameMTL | ( | VTK_FILEPATH const char * | arg | ) |

Specify the name of the file to read.

## ◆ SetTexturePath()

void vtkOBJImporter::SetTexturePath | ( | VTK_FILEPATH const char * | path | ) |

Specify the name of the file to read.

## ◆ GetFileName()

VTK_FILEPATH const char* vtkOBJImporter::GetFileName | ( |  | ) | const

Specify the name of the file to read.

## ◆ GetFileNameMTL()

VTK_FILEPATH const char* vtkOBJImporter::GetFileNameMTL | ( |  | ) | const

Specify the name of the file to read.

## ◆ GetTexturePath()

VTK_FILEPATH const char* vtkOBJImporter::GetTexturePath | ( |  | ) | const

Specify the name of the file to read.

## ◆ GetOutputsDescription()

std::string vtkOBJImporter::GetOutputsDescription | ( |  | ) |
| overridevirtual

Get a printable string describing all outputs.

Reimplemented from vtkImporter.

## ◆ GetOutputDescription()

std::string vtkOBJImporter::GetOutputDescription | ( | int | idx | ) |

Get a string describing an output.

## ◆ ImportBegin()

int vtkOBJImporter::ImportBegin | ( |  | ) |
| overrideprotectedvirtual

Reimplemented from vtkImporter.

## ◆ ImportEnd()

void vtkOBJImporter::ImportEnd | ( |  | ) |
| overrideprotectedvirtual

Reimplemented from vtkImporter.

## ◆ ReadData()

void vtkOBJImporter::ReadData | ( |  | ) |
| overrideprotectedvirtual

Reimplemented from vtkImporter.

## Member Data Documentation

## ◆ Impl

vtkSmartPointer<vtkOBJPolyDataProcessor> vtkOBJImporter::Impl
| protected

Definition at line 104 of file vtkOBJImporter.h.

The documentation for this class was generated from the following file:

- IO/Import/vtkOBJImporter.h